/**************************************************
 Configuration of AT for 64 bit linux platform.

Author: 
Jianfeng ZHANG @ LAL 12/02/2013
**************************************************/


1)at/simulator/element: elempass.h: 
add the line to define mex compile for the 64 bit linux matlab version:

#define ExportMode
#elif defined(GLNXA64) /*64 bit linux version matlab*/

2) at/simulator/element/mexpassmethod.m:
Modified the mex compiler options for 64 bit linux:

    case 'GLNXA64'
         PLATFORMOPTION = [PLATFORMOPTION,'LDFLAGS=''-pthread -shared -m64 -Wl''',' '];

3) at/simulator/element/user/elempass.h
Added the mex compiler platform for 64 bit linux: 

#define ExportMode
#elif defined(GLNXA64) 

4) at/simulator/element/user/mexuserpassmethod.m
Modified the mex compiler options for 64 bit linux:

  case 'GLNXA64'
     PLATFORMOPTION = [PLATFORMOPTION,'LDFLAGS=''-pthread -shared -m64 -Wl''',' '];

5) at/atmexall.m
 Added the mex compile for 64 bit linux platform.

 case 'GLNXA64'
        PLATFORMOPTION = ['-ldl -D',computer,' '];

6)at/simulator/track/atpass.c

Addedthe definition of platform for the 64 bit linux platform:

#elif defined(GLNXA64)
#include <dlfcn.h>
#define MEXEXTENSIONSTRING ".mexglxa64"
#define PASSMETHODSUBDIRSTRING "/simulator/element/"
#define LIBRARYHANDLETYPE void*
#define FREELIBFCN(libfilename) dlclose(libfilename)
#define LOADLIBFCN(libfilename) dlopen((libfilename),RTLD_LAZY)
#define GETPASSFCN(libfilename) dlsym((libfilename),"passFunction")


/************************************/
       AT source code  log 
/************************************/

(1)  29/04/2013

!----------------------------------------------------------------
! To define a new pass method in AT, the name of the pass method
! must be ended with "*Pass.c", otherwise "mexall" command
! can't find the pass method (see details in "mexpassmethod.c").
!----------------------------------------------------------------

(a):
Copy "at/simulator/element/BndMPoleSymplectic4Pass.c":
to 
"at/simulator/element/user/BndMPoleSymplecticNew4Pass.c"
to 
fix the bug in the trigger on edge effects and fringe field for 
sector dipoles. 

In "at/simulator/element/user/BndMPoleSymplecticNew4Pass.c":

change
"if( fint1==0 || gap==0 || entrance_angle == 0)" 
to 
"if(EdgeEffect1 = 1)"

and change 
" if( fint2==0 || gap==0 || exit_angle == 0)" 
to 
"if(EdgeEffect2 = 2)"

 (b):
    Copy "at/simulator/element/user/rbend2.m"
     to
        "at/simulator/element/user/rbend3.m".
    fix the potential bug to trigger on the fringe field and
    edge effects for sector dipoles in "at/simulator/element/user/rbend3.m":

 Change the definition of dipole from 
 " rbend2(fname,L,A,A1,A2,K,gap, method)"
 to
 " rbend2(fname,L,A,A1,A2,K,gap,EdgeEffect1,EdgeEffect2, method)"      
 
  (c)
    Add the new flags "int EdgeEffect1" and "int EdgeEffect2" in the 
    function definition of "BndMPoleSymplectic4Pass()" in 
    "BndMPoleSymplecticNew4Pass.c";

    change accordingly the function passFunction() in 
    "BndMPoleSymplecticNew4Pass.c".

  (d) Copy atphyslib.c to user/atphyslibNew.c, and add the geometric correction
      to the edge focusing of the dipole:
       Change 
      "fy = inv_rho*tan(psi_bar);" to 
     "
     if(entrance == 1)
     fy = inv_rho*tan(psi_bar + r[1]/(1+r[4]));
     else
     fy = inv_rho*tan(psi_bar - r[1]/(1+r[4]));"
(e)
    05/06/2013 
   Added Alex Loulergue's geometric correction of the 
dipole fringe field, but without the correction
term 1+r[4] of py in Forest: SSC-141; because this 
correction term only works for Soleil lattice, but not works
for ThomX and SuperB DR.

In user/atphyslibNew.c
change 
" r[3]-=r[2]*fy/(1+r[4]*1);" 
to 
" r[1]+=r[0]*fx/(1+r[4]*0);"

(2) 30/04/2013

   Which function "atphysics.h" is called in the path "element/simulator/user"?
   In the path "element/simulator/user" or "element/simulator"?

   The first meet is the first one to be called.

   How to call the function in the upper path? See "BndMPoleSymplecticNew4Pass.c"

use:  #include"..\*.h" or #include"..\*.c"


17/06/2013
Change the file name "/home/jfz/codes/MML_ThomX/machine/SOLEIL/Booster/applications/set_param.m" t0 "/home/jfz/codes/MML_ThomX/machine/SOLEIL/Booster/applications/set_para.m", 
since the file name "set_param.m" is conflict with the Matlab buildin
file "set_param.m". 

This may cause problems in some SOLEIL applications which call
this local "set_param.m" file.


04/10/2013

(1) linopt.m 
    Fix the bug to avoid the mirror tunes of ThomX ring.
    Using the sign of M12.

07/10/2013

(1)tunechrom.m 
   Fix the bug to avoid the mirror tunes.


