% get the synchrotron radiation energy of the reference particle

c = 2.99792458e+8; % m/s

Cr = 8.846*1e-5; % m/GeV^3

E = 50e-3; % GeV 

E0 = 0.511099891e-3;  

p = sqrt(E^2 - E0^2)/c * 1e9;



rho = 0.352; % m

B = p/rho %0.4738 T

beta = sqrt(1-E0^2/E^2);

U0 = Cr*beta^3*E^4/rho*1e6 %[keV]

