function TLsetup
%LT2SETUP - GUI to setup LT2 

%
% Written by Laurent S. Nadolski
% Modified by Jianfeng Zhang @ LAL, 17/06/2013 (Not complete...)

AD = getad;

if isempty(AD) 
    TLinit;
elseif ~strcmpi(AD.SubMachine,'TL')
    TLinit;
end

orbfig = findobj(allchild(0),'tag','TLsetup'); 

if ~isempty(orbfig), delete(orbfig); end
orbfig = findobj(allchild(0),'tag','TLsetup'); 


kmax = 4; % button number

height = 10 + kmax*30 + 30; %670;
a = figure('Color',[0.8 0.8 0.8], ...
    'Interruptible', 'on', ...   
    'HandleVisibility','off', ...
    'MenuBar','none', ...
    'Name', 'TL Command Launcher', ...
    'NumberTitle','off', ...
    'Units','pixels', ...
    'Position',[5 70 210*2 height], ...
    'Resize','off', ...
    'Tag','TLsetup');

height = height - 35;

for k = 1:kmax,
    b1(k) = uicontrol('Parent',a, ...
        'Position',[3 height-(k-1)*30 204 27], ...
        'Interruptible', 'off', ...
        'Tag','button22');
end

for k = 1:kmax,
    b2(k) = uicontrol('Parent',a, ...
        'Position',[3 + 210 height-(k-1)*30 204 27], ...
        'Interruptible', 'off', ...
        'Tag','button22');
end

%set(b1(1), 'Callback','disp([''   TLinit;'']); cd(getenv(''MLROOT'')); setpaththomx(''TL'');', 'String','TLinit');
set(b1(1), 'Callback','disp([''   TLinit;'']); cd(getmmlroot); setpaththomx(''TL'');', 'String','TLinit','ForegroundColor','r');
set(b1(2), 'Callback','disp([''   Fichiers de Consignes;'']); configgui;;', 'String','Fichiers de Consignes','ForegroundColor','r');
% same programme for TL cycling
set(b1(3), 'Callback','disp([''   TLcycling;'']);TLcycling', 'String','Cyclage','ForegroundColor','r');
% need to customized the synchrotronizer for ThomX
set(b1(4), 'Callback','disp([''   Timing;'']); synchro_injecteur7;', 'String','Synchronisation définitive');
set(b2(1), 'Callback','optics_TL;', 'String','OPTIQUE','ForegroundColor','r');
%need to customized for ThomX 
set(b2(2), 'Callback','disp([''   Emittance'']);emittance_v15;', 'String','Emittance');

b = uicontrol('Parent',a, ...
    'Callback','close all', ...
    'String','Close All Figures', ...
    'Position',[3 height-kmax*30 204 27], ...
    'Userdata',[], ...
    'Interruptible', 'off', ...   
    'Tag','button2');

b = uicontrol('Parent',a, ...
    'Callback','diary off; close(get(findobj(gcbf,''Tag'',''button1''),''Userdata''));', ...
    'Position',[3 + 210 height-kmax*30 204 27], ...
    'String','CLOSE', ...
    'Userdata',a, ...
    'Interruptible', 'off', ...   
    'Tag','button1');

